# coding: utf-8

from __future__ import absolute_import
from datetime import date, datetime  # noqa: F401

from typing import List, Dict  # noqa: F401

from swagger_server.models.base_model_ import Model
from swagger_server.models.traffic_format_direction import TrafficFormatDirection  # noqa: F401,E501
from swagger_server import util


class TrafficFormats(Model):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    def __init__(self, direction: TrafficFormatDirection=None, format: str=None, packets: int=None, volume: int=None):  # noqa: E501
        """TrafficFormats - a model defined in Swagger

        :param direction: The direction of this TrafficFormats.  # noqa: E501
        :type direction: TrafficFormatDirection
        :param format: The format of this TrafficFormats.  # noqa: E501
        :type format: str
        :param packets: The packets of this TrafficFormats.  # noqa: E501
        :type packets: int
        :param volume: The volume of this TrafficFormats.  # noqa: E501
        :type volume: int
        """
        self.swagger_types = {
            'direction': TrafficFormatDirection,
            'format': str,
            'packets': int,
            'volume': int
        }

        self.attribute_map = {
            'direction': 'direction',
            'format': 'format',
            'packets': 'packets',
            'volume': 'volume'
        }
        self._direction = direction
        self._format = format
        self._packets = packets
        self._volume = volume

    @classmethod
    def from_dict(cls, dikt) -> 'TrafficFormats':
        """Returns the dict as a model

        :param dikt: A dict.
        :type: dict
        :return: The TrafficFormats of this TrafficFormats.  # noqa: E501
        :rtype: TrafficFormats
        """
        return util.deserialize_model(dikt, cls)

    @property
    def direction(self) -> TrafficFormatDirection:
        """Gets the direction of this TrafficFormats.


        :return: The direction of this TrafficFormats.
        :rtype: TrafficFormatDirection
        """
        return self._direction

    @direction.setter
    def direction(self, direction: TrafficFormatDirection):
        """Sets the direction of this TrafficFormats.


        :param direction: The direction of this TrafficFormats.
        :type direction: TrafficFormatDirection
        """
        if direction is None:
            raise ValueError("Invalid value for `direction`, must not be `None`")  # noqa: E501

        self._direction = direction

    @property
    def format(self) -> str:
        """Gets the format of this TrafficFormats.


        :return: The format of this TrafficFormats.
        :rtype: str
        """
        return self._format

    @format.setter
    def format(self, format: str):
        """Sets the format of this TrafficFormats.


        :param format: The format of this TrafficFormats.
        :type format: str
        """
        if format is None:
            raise ValueError("Invalid value for `format`, must not be `None`")  # noqa: E501

        self._format = format

    @property
    def packets(self) -> int:
        """Gets the packets of this TrafficFormats.


        :return: The packets of this TrafficFormats.
        :rtype: int
        """
        return self._packets

    @packets.setter
    def packets(self, packets: int):
        """Sets the packets of this TrafficFormats.


        :param packets: The packets of this TrafficFormats.
        :type packets: int
        """
        if packets is None:
            raise ValueError("Invalid value for `packets`, must not be `None`")  # noqa: E501

        self._packets = packets

    @property
    def volume(self) -> int:
        """Gets the volume of this TrafficFormats.


        :return: The volume of this TrafficFormats.
        :rtype: int
        """
        return self._volume

    @volume.setter
    def volume(self, volume: int):
        """Sets the volume of this TrafficFormats.


        :param volume: The volume of this TrafficFormats.
        :type volume: int
        """
        if volume is None:
            raise ValueError("Invalid value for `volume`, must not be `None`")  # noqa: E501

        self._volume = volume
